local fallingTreeModUsed = false

woodList = {
  [0] = "minecraft:oak_log",
  [1] = "minecraft:dark_oak_log",
  [2] = "minecraft:spruce_log",
}

local function isWood(blockData)
  for i=0, #woodList do
    if blockData["name"] == woodList[i] then
      return true
    end
  end
  return false
end

local function recursiveTreeFarming()
  for i=0, 3 do
    turtle.turnLeft()
    blockFound, blockData = turtle.inspect()
    if isWood(blockData) then
      turtle.dig()
      turtle.forward()
      recursiveTreeFarming()
      turtle.back()
    end
  end

  blockFound, blockData = turtle.inspectUp()
  if isWood(blockData) then
    turtle.digUp()
    turtle.up()
    recursiveTreeFarming()
    turtle.down()
  end

  blockFound, blockData = turtle.inspectDown()
  if isWood(blockData) then
    turtle.digDown()
    turtle.down()
    recursiveTreeFarming()
    turtle.up()
  end
end


local function placeTree()
  for i=1, 16 do
    turtle.select(i)
    local itemDetail = turtle.getItemDetail()

    if itemDetail ~= nil then
      if itemDetail.name == "minecraft:spruce_sapling" then
        local blockFound, blockData = turtle.inspect()
        if not blockFound then
          sleep(3)
          turtle.up()
          turtle.forward()
          for i=0, 3 do
            turtle.suckDown()
            turtle.placeDown()
            turtle.forward()
            turtle.turnRight()
          end
          turtle.back()
          turtle.down()
        end
      end
    end
  end
end

local function emptyInventory()
  for i=1, 16 do
    turtle.select(i)
    itemDetail = turtle.getItemDetail()
    if itemDetail ~= nil then
      if itemDetail.name == "minecraft:spruce_log" then
        turtle.refuel()
        turtle.dropDown()
      end
    end
  end
end

function main()
  if fallingTreeModUsed then
    while true do
      blockFound, blockData = turtle.inspect()
      if blockFound then
        if isWood(blockData) then
          turtle.dig()
          sleep(1)
          placeTree()
          emptyInventory()
        end
        print("waiting for tree...")
        sleep(10)
      else
        placeTree()
      end
    end
  else
    while true do
      blockFound, blockData = turtle.inspect()
      if blockFound then
        if isWood(blockData) then
          recursiveTreeFarming()
          sleep(1)
          placeTree()
          emptyInventory()
        end
        print("Fuel at " .. turtle.getFuelLevel())
        print("waiting...")
        sleep(10)
      else 
        placeTree()
      end
    end
  end
end

main()
